/* FILE: randomscalarfield.h      -*-Mode: c++-*-
 *
 * Random scalar field object, derived from Oxs_ScalarField class.
 *
 */

#ifndef _OXS_RANDOMSCALARFIELD
#define _OXS_RANDOMSCALARFIELD

#include "oc.h"

#include "scalarfield.h"

/* End includes */

class Oxs_RandomScalarField:public Oxs_ScalarField {
private:
  REAL8m range_min;
  REAL8m range_max;
public:
  virtual const char* ClassName() const; // ClassName() is
  /// automatically generated by the OXS_EXT_REGISTER macro.
  virtual BOOL Init();
  Oxs_RandomScalarField
  (const char* name,     // Child instance id
   Oxs_Director* newdtr, // App director
   const char* argstr);  // MIF input block parameters

  virtual ~Oxs_RandomScalarField() {}

  virtual REAL8m Value(const ThreeVector& pt) const;

  virtual void FillMeshValue(const Oxs_Mesh* mesh,
			     Oxs_MeshValue<REAL8m>& array) const;
};


#endif // _OXS_RANDOMSCALARFIELD

