/* FILE: scriptscalarfield.h      -*-Mode: c++-*-
 *
 * Tcl script scalar field object, derived from Oxs_ScalarField
 * class.
 *
 */

#ifndef _OXS_SCRIPTSCALARFIELD
#define _OXS_SCRIPTSCALARFIELD

#include <string>
#include <vector>

#include "oc.h"

#include "scalarfield.h"
#include "threevector.h"
#include "tclcommand.h"

/* End includes */

class Oxs_ScriptScalarField:public Oxs_ScalarField {
private:
  Oxs_ThreeVector basept;
  Oxs_ThreeVector scale;
  vector<Oxs_TclCommandLineOption> command_options;
  Oxs_TclCommand cmd;
public:
  virtual const char* ClassName() const; // ClassName() is
  /// automatically generated by the OXS_EXT_REGISTER macro.
  virtual BOOL Init();
  Oxs_ScriptScalarField
  (const char* name,     // Child instance id
   Oxs_Director* newdtr, // App director
   const char* argstr);  // MIF input block parameters

  virtual ~Oxs_ScriptScalarField();

  virtual REAL8m Value(const ThreeVector& pt) const;

  virtual void FillMeshValue(const Oxs_Mesh* mesh,
			     Oxs_MeshValue<REAL8m>& array) const;

};


#endif // _OXS_SCRIPTSCALARFIELD
