/* FILE: autobuf.h                    -*-Mode: c++-*-
 *
 *	For converting string literals into the writable strings needed
 * as arguments to Tcl library calls.
 * 
 * NOTICE: Please see the file ../../LICENSE
 *
 * Last modified on: $Date: 2001/07/18 08:09:02 $
 * Last modified by: $Author: donahue $
 */

#ifndef _OC_AUTOBUF
#define _OC_AUTOBUF

#include <stddef.h>  // size_t definition

class Oc_AutoBuf
{
private:
  static const size_t reclaim_bound;
  static const size_t reclaim_proportion;
  size_t bufsize; // Length of buffer pointed to by str. ( >= strlen(str)+1.)
  char *str;
public:
  Oc_AutoBuf();
  Oc_AutoBuf(const char* const_str);
  ~Oc_AutoBuf();
  operator char*() const { return str; }
  char* GetStr() const { return str; }
  char* operator()(const char* const_str);
  void Dup(const char* const_str);
  void SetLength(size_t new_length); // bufsize = length + 1
  size_t GetLength() { return bufsize-1; }
}; 

#endif /* _OC_AUTOBUF */

